routes/web.php
<?php

use App\Http\Controllers\CommentController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\VotesController;
use App\Models\Category;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ContactController;
use App\Http\Controllers\PostController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');


Route::middleware('auth')->group(function () {

    Route::get('/home', function () {
        return view('home');
    })->name('home');

    Route::get('/about-us', function () {
        return view('about');
    })->name('about-us');

    //Contacts
    Route::get('/contact-us', function () {
        return view('contacts');
    })->name('contact-us');


//Posts
    Route::post('/contact-us', [ContactController::class, 'store'])->name('contact.us.store');

    Route::get('/blog-page', [PostController::class, 'index'])->name('blog-page');

    Route::resource('/posts', PostController::class);

    //Categories
    Route::get('/categories/{category:slug}', function (Category $category) {
        return view('categories.index', ['category' => $category]);
    });

    //Votes
    Route::post('/votes/{post}/like', [VotesController::class, 'likes'])->name('likes');
    Route::post('/votes/{post}/dislike', [VotesController::class, 'dislikes'])->name('dislikes');

    //Comments
    Route::get('/comment/index/{slug}', [CommentController::class, 'index'])->name('comment.index');
    Route::post('/comment/store', [CommentController::class, 'store'])->name('comment.add');


    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__ . '/auth.php';

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Post extends Model
{
    use HasFactory;


    protected $fillable = [
        'user_id',
        'title',
        'slug',
        'description',
        'category_id',
        'post_id',
        'liked'

    ];

    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class);
    }

    public function votes(): HasMany
    {
        return $this->hasMany(Votes::class);
    }

    /**
     * The has Many Relationship
     *
     * @var array
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class);
    }


    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }


    public function like($user, $liked = true): object
    {
        return $this->votes()->updateOrCreate(['user_id' => $user->id,], ['liked' => $liked]);
    }


    public function dislike($user): string
    {
        return $this->like($user, false);
    }


    //potentional functionality to show most hated posts
    public function dislikes(): HasMany
    {
        return $this->hasMany(Votes::class)->where('liked', false);
    }


    public function likes(): HasMany
    {
        return $this->hasMany(Votes::class)->where('liked', true);
    }


}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StorePostRequest;
use App\Models\Post;
use App\Repository\Interfaces\PostRepositoryInterface;
use App\Repository\PostRepository;
use Illuminate\Http\RedirectResponse;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Redirect;
use Illuminate\View\View;

class PostController extends Controller
{

    /**
     * @var mixed|PostRepositoryInterface
     */

    private mixed $postRepository;

    /**
     * PostController constructor.
     * @param PostRepository $postRepository
     */

    public function __construct(PostRepository $postRepository)
    {
        $this->postRepository = $postRepository;
    }

    public function index(): View
    {
        $posts = $this->postRepository->index();
        return view('posts.index', compact('posts'));
    }

    /**
     * @return View
     */
    public function create(): View
    {
        $categories = $this->postRepository->create();
        return view('posts.create', compact('categories'));
    }

    public function store(StorePostRequest $request): RedirectResponse
    {
        $this->postRepository->store($request);
        return redirect()->route('posts.index')->with('status', 'Post Created Successfully');
    }

    /**
     * @param Post $post
     * @return View
     */

    public function show(Post $post): View
    {
        $like = $this->postRepository->show($post);
        return view('posts.show', compact('post', 'like'));
    }

    /**
     * Verify user to edit own post
     * @param Post $post
     * @return object
     */
    public function edit(Post $post): object
    {
        if (Auth::user()->getAuthIdentifier() === $post->user_id) {
            $categories = $this->postRepository->edit();
            return view('posts.edit', compact('categories', 'post'));
        }
        return Redirect::route('posts.index')->with('error', 'Sorry,not allowed to edit others posts.');

    }

    /**
     *
     * @param StorePostRequest $request
     * @param $id
     * @return RedirectResponse
     */
    public function update(StorePostRequest $request, $id): RedirectResponse
    {
        $this->postRepository->update($request, $id);
        return Redirect::route('posts.index')->with('status', 'Post Updated Successfully');
    }

    /**
     * Verify user to delete own posts only
     * @param Post $post

     */
    public function destroy(Post $post): RedirectResponse
    {
        if (Auth::user()->getAuthIdentifier() === $post->user_id) {
            return Redirect::back()->with('status', 'Post deleted successfully');
        }
        return Redirect::route('posts.index')->with('error', 'Sorry,not allowed to delete others posts');
    }

}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;
use Illuminate\View\View;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     */
    public function render(): View
    {
        return view('layouts.app');
    }
}

resources/views/posts/create.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="text-xl font-semibold leading-tight text-gray-800">
            {{ __('Post Create') }}
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="mx-auto max-w-7xl sm:px-6 lg:px-8">
            <div class="overflow-hidden bg-white shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    <form method="POST" action="{{ route('posts.store') }}">
                        @csrf
                        <div class="mb-6">
                            <label class="block">
                                <span class="text-gray-700">Title</span>
                                <input type="text" name="title"
                                       class="block w-full @error('title') border-red-500 @enderror mt-1 rounded-md"
                                       placeholder="" value="{{old('title')}}" />
                            </label>
                            @error('title')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-6">
                            <label class="block">
                                <span class="text-gray-700">Slug</span>
                                <input type="text" name="slug"
                                       class="block w-full @error('slug') border-red-500 @enderror mt-1 rounded-md"
                                       placeholder="" value="{{old('slug')}}" />
                            </label>
                            @error('slug')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-6 ">
                            <label class="block">
                                <span class="text-gray-700">Select Category</span>
                                <select name="category_id" class="block w-full mt-1 rounded-md">
                                    @foreach ($categories as $category)
                                        <option value="{{$category->id}}">{{$category->name}}</option>
                                    @endforeach
                                </select>
                            </label>
                            @error('category_id')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-6">
                            <label class="block">
                                <span class="text-gray-700">Description</span>
                                <textarea class="block w-full mt-1 rounded-md" name="description"
                                          rows="3">{{old('description')}}</textarea>
                            </label>
                            @error('description')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group text-center">
                            <input type="submit" value="Create">
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/posts/edit.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="text-xl font-semibold leading-tight text-gray-800">
            {{ __('Post Edit') }}
        </h2>
        <meta charset="utf-8"/>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
        <meta name="viewport" content="width=device-width, initial-scale=1">
    </x-slot>

    <div class="py-12">
        <div class="mx-auto max-w-7xl sm:px-6 lg:px-8">
            <div class="overflow-hidden bg-white shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    <form method="POST" action="{{ route('posts.update',$post->id) }}">
                        @csrf
                        @method('put')
                        <div class="mb-6">
                            <label class="block">
                                <span class="text-gray-700">Title</span>
                                <input type="text" name="title"
                                       class="block w-full @error('title') border-red-500 @enderror mt-1 rounded-md"
                                       placeholder="" value="{{old('title',$post->title)}}" />
                            </label>
                            @error('title')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-6">
                            <label class="block">
                                <span class="text-gray-700">Slug</span>
                                <input type="text" name="slug"
                                       class="block w-full @error('slug') border-red-500 @enderror mt-1 rounded-md"
                                       placeholder="" value="{{old('slug',$post->slug)}}" />
                            </label>
                            @error('slug')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-6">
                            <label class="block">
                                <span class="text-gray-700">Select Category</span>
                                <select name="category_id" class="block w-full mt-1 rounded-md">
                                    @foreach ($categories as $category)
                                        <option @selected($category->id == $post->category_id)
                                                value="{{$category->id}}">{{$category->name}}</option>
                                    @endforeach
                                </select>
                            </label>
                            @error('category_id')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="mb-6">
                            <label class="block">
                                <span class="text-gray-700">Description</span>
                                <textarea class="block w-full mt-1 rounded-md" name="description"
                                          rows="3">{{ $post->description}}</textarea>
                            </label>
                            @error('description')
                            <div class="text-sm text-red-600">{{ $message }}</div>
                            @enderror
                        </div>
                        <input type="submit" class="px-4 py-2 text-white rounded"
                               value="Submit">
                    </form>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/posts/index.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="text-xl font-semibold leading-tight text-gray-800">
            {{ __('Blog Posts') }}
        </h2>
        <meta charset="utf-8"/>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
        <meta name="viewport" content="width=device-width, initial-scale=1">
    </x-slot>

    <div class="py-12">
        <div class="mx-auto max-w-7xl sm:px-6 lg:px-8">
            <div class="overflow-hidden bg-white shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    <div x-data="{ showMessage: true }" x-show="showMessage" class="flex justify-center">
                        @if (session()->has('status'))
                            <div
                                class="flex items-center justify-between max-w-xl p-4 bg-white border rounded-md shadow-sm">
                                <div class="flex items-center">
                                    <svg xmlns="http://www.w3.org/2000/svg" class="w-8 h-8 text-green-500"
                                         viewBox="0 0 20 20" fill="currentColor">
                                        <path fill-rule="evenodd"
                                              d="M10 18a8 8 0 100-16 8 8 0 000 16zm3.707-9.293a1 1 0 00-1.414-1.414L9 10.586 7.707 9.293a1 1 0 00-1.414 1.414l2 2a1 1 0 001.414 0l4-4z"
                                              clip-rule="evenodd"/>
                                    </svg>
                                    <p class="ml-3 text-sm font-bold text-green-600">{{ session()->get('status') }}</p>
                                </div>
                                <span @click="showMessage = false" class="inline-flex items-center cursor-pointer">
                                <svg xmlns="http://www.w3.org/2000/svg" class="w-4 h-4 text-gray-600" fill="none"
                                     viewBox="0 0 24 24" stroke="currentColor">
                                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
                                          d="M6 18L18 6M6 6l12 12"/>
                                </svg>
                            </span>
                            </div>
                        @elseif (session()->has('error'))
                            <p class="ml-3 text-sm font-bold text-red-600">{{ session()->get('error') }}</p>
                        @endif
                    </div>

                    <div class="mt-1 mb-4 flex-right">
                        <a class="px-2 py-2 text-sm text-white bg-blue-600 rounded"
                           href="{{ route('posts.create') }}">{{ __('Add New Post') }}</a>
                    </div>
                    <div class="relative overflow-x-auto shadow-md sm:rounded-lg">
                        <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400">
                            <thead
                                class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
                            <tr>
                                <th scope="col" class="px-6 py-3">
                                    #
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Title
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Category
                                </th>
                                <th scope="col" class="px-6 py-3 "  >
                                    Votes Up
                                </th>

                                <th scope="col" class="px-6 py-3">
                                    Votes Down
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    <div>Commented#</div>
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Edit
                                </th>
                                <th scope="col" class="px-6 py-3">
                                    Show
                                </th>

                                <th scope="col" class="px-6 py-3">
                                    Delete
                                </th>
                            </tr>
                            </thead>
                            <tbody>

                            @foreach ($posts as $post)
                                <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                                    <th scope="row"
                                        class="px-6 py-4 font-medium text-gray-900 dark:text-white whitespace-nowrap">
                                        {{$post->id}}
                                    </th>
                                    <td class="px-6 py-4">
                                        {{$post->title}}

                                    </td>
                                    <td class="px-6 py-4">
                                        <a href="/categories/{{$post->category->slug}}">{{$post->category->name}}</a>

                                    </td>
                                    <td class="px-6 py-4">
                                    <p>{{$post["likes_count"]}}</p>
                                    </td>

                                    <td class="px-6 py-4">
                                        <p>{{$post["dislikes_count"]}}</p>
                                    </td>
                                    <td class="px-6 py-4 text-danger underline ">
                                        <a href="/comment/index/{{$post->id}}">{{$post->comments->count()}}</a>
                                    </td>
                                    <td class="px-6 py-4">
                                        <a href="{{ route('posts.edit',$post->id) }}">Edit</a>
                                    </td>
                                    <td class="px-6 py-4">
                                        <a href="{{ route('posts.show',$post->id) }}">Show</a>
                                    </td>
                                    <td class="px-6 py-4">
                                        <form action="{{ route('posts.destroy',$post->id) }}" method="POST"
                                              onsubmit="return confirm('{{ trans('are You Sure ? ') }}');"
                                              style="display: inline-block;">
                                            @csrf
                                            <input type="hidden" name="_method" value="DELETE">

                                            <input type="submit" class="px-4 py-2 text-white rounded"
                                                   value="Delete">
                                        </form>
                                    </td>
                                </tr>
                            @endforeach
                            </tbody>

                        </table>

                    </div>
                    <div class="py-10 pl-14 m-1">
                        {{$posts->links()}}
                    </div>
                </div>

            </div>
        </div>
    </div>
</x-app-layout>

resources/views/posts/show.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="text-xl font-semibold leading-tight text-gray-800">
            {{ __('Blog posts') }}
        </h2>
        <meta charset="utf-8"/>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <link rel="stylesheet" href="{{ URL::asset('css/style.css') }}">
        <link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
        <meta name="viewport" content="width=device-width, initial-scale=1">

    </x-slot>

    <div class="relative overflow-x-auto shadow-md sm:rounded-lg">
        <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400 ">
            <thead
                class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
            <tr>
                <th scope="col" class="px-6 py-3">
                    Post#
                </th>
                <th scope="col" class="px-6 py-3">
                    Title
                </th>

                <th scope="col" class="px-6 py-3">
                    Content
                </th>

                <th scope="col" class="px-6 py-3">
                    <p class="text-red ">Vote Now</p>
                </th>

            </tr>
            </thead>
            <tbody>

            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row"
                    class="px-6 py-3 font-medium text-gray-900 dark:text-white whitespace-nowrap">
                {{$post->id}}

                <td class="px-6 py-3 ">
                    {{$post->title}}
                </td>

                <td class="px-6 py-3">
                    <p class=" align-baseline ">{{$post->description}}</p>

                </td>

                <td class="px-9 py-3 pl-5">
                    @if($like == null  )
                        <form action="{{ route('likes', $post) }}" method="POST"
                              onsubmit="return confirm('{{ trans('Thank you! ') }}');"
                              style="display: inline-block;">
                            @csrf
                            <button type="submit">
                                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="red"
                                     class="w-5 h-5">
                                    <path
                                        d="M1 8.25a1.25 1.25 0 112.5 0v7.5a1.25 1.25 0 11-2.5 0v-7.5zM11 3V1.7c0-.268.14-.526.395-.607A2 2 0 0114 3c0 .995-.182 1.948-.514 2.826-.204.54.166 1.174.744 1.174h2.52c1.243 0 2.261 1.01 2.146 2.247a23.864 23.864 0 01-1.341 5.974C17.153 16.323 16.072 17 14.9 17h-3.192a3 3 0 01-1.341-.317l-2.734-1.366A3 3 0 006.292 15H5V8h.963c.685 0 1.258-.483 1.612-1.068a4.011 4.011 0 012.166-1.73c.432-.143.853-.386 1.011-.814.16-.432.248-.9.248-1.388z"/>
                                </svg>
                            </button>

                        </form>

                        <form action="{{ route('dislikes', $post->id) }}" method="POST"
                              onsubmit="return confirm('{{ trans('Thank you! ') }}');"
                              style="display: inline-block;">

                            @csrf
                            <button type="submit">
                                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="blue"
                                     class="w-5 h-5">
                                    <path
                                        d="M18.905 12.75a1.25 1.25 0 01-2.5 0v-7.5a1.25 1.25 0 112.5 0v7.5zM8.905 17v1.3c0 .268-.14.526-.395.607A2 2 0 015.905 17c0-.995.182-1.948.514-2.826.204-.54-.166-1.174-.744-1.174h-2.52c-1.242 0-2.26-1.01-2.146-2.247.193-2.08.652-4.082 1.341-5.974C2.752 3.678 3.833 3 5.005 3h3.192a3 3 0 011.342.317l2.733 1.366A3 3 0 0013.613 5h1.292v7h-.963c-.684 0-1.258.482-1.612 1.068a4.012 4.012 0 01-2.165 1.73c-.433.143-.854.386-1.012.814-.16.432-.248.9-.248 1.388z"/>
                                </svg>
                            </button>

                        </form>
                    @endif

                    @if($like)
                        <p class="px-1 py-3 font-medium text-red-500 dark:text-white whitespace-nowrap">{{ $like->liked ? 'Liked' : 'Not liked' }}</p>
                    @endif
                </td>
            </tr>
            </tbody>
        </table>

        <div class="max-w-2xl mx-auto p-4 sm:p-6 lg:p-8">
            <form method="post" action="{{ route('comment.add') }}">

                @csrf

                <div class="form-group">
                    <input type="text" name="comment_body" class="form-control"/>
                    <input type="hidden" name="post_id" value="{{ $post->id }}"/>
                </div>

                <button
                    class="bg-white hover:bg-red-500 text-gray-800 text-tahiti mt-3 py-1 px-4 border border-gray-400 rounded shadow">
                    {{ __('Send') }}
                </button>
                <button
                    class="bg-white  hover:bg-[#1da1f2] text-gray-800 text-tahiti mt-3 py-1  px-4 border border-gray-400 rounded shadow">
                    <a href="{{ route('posts.index') }}" class="btn btn-default">Back</a>
                </button>
            </form>
        </div>
    </div>
</x-app-layout>